#define AIN1 60
#define AIN2 58
#define DIN 211
#define DOUT 81
#define PWM 64
#define AOUT 64
//---- GPIO ----
#define PWMPIN 10
#define LED 8  //

// GPIO ESP32-C3 SUPER MINI 

//DIGITAL OUT PINS 0 - 7 CLAB
byte Dout[] = {21, 20, 10, 9, 8, 7, 6, 5};//BUTTON = 9
//DIGITAL IN  PINS 0 - 7 CLAB
byte Dins[]  = {0,1,2}; 
//ANALOG IN PINS A - B CLAB
byte Ains[]  = {A4,A3};
//BitValues
byte Bits[]  = {1,2,4,8,16,32,64,128};

void setup()
{ Serial.begin(9600); //Special CLAB
  for(int i= 0;i<2;i++)pinMode(Ains [i],INPUT);
  for(int i= 0;i<3;i++)pinMode(Dins [i],INPUT_PULLUP);
  for(int i= 0;i<8;i++)pinMode(Dout [i],OUTPUT);
}

void loop()
{ int i, val, inbyte; byte b;
  val = Serial.available(); //Was da?
  if (val>0)
  {inbyte=Serial.read(); //abholen
   delay(5);
   switch(inbyte)
  { case 13  : //CLAB ID nur ab Compact 1.75!
               Serial.write(3);delay(2);break; //ID
    case DIN : for(i=0,b=0;i<3;i++) //PINS to BYTE
                b+= (digitalRead(Dins[i])==HIGH?Bits[i]:0);
               Serial.write(b);break; 
    /*
    case AOUT: b=Serial.read(); //Ausgabebyte holen
               dacWrite(DAC1, b); //esp32 DAC 1  
               dacWrite(DAC2, b); //esp32 DAC 2  
               break;
  */
    case DOUT: b=Serial.read(); //Ausgabebyte holen
               for(i=0;i<8;i++)
                digitalWrite(Dout[i],b&Bits[i]?HIGH:LOW);
               break;
  /*
    case PWM:  b=Serial.read(); //Ausgabebyte holen
               analogWrite(PWMPIN,b);
               break;
  */  
    case AIN1: 
    case 48:   Serial.write(analogRead(Ains[0])>>4);break;
    case AIN2: 
    case 49:   Serial.write(analogRead(Ains[1])>>4);break;
    default:   break;
  }
 }
 delay(0);
}
